// This file is common to the XML Moo Database browser and Moo Canada's IDE.

var TreeFrame, ListFrame, CodeFrame, XmlDoc;

function onloadBody() {
  TreeFrame = this.frames[0].frames[0];
  ListFrame = this.frames[0].frames[1];
  CodeFrame = this.frames[1];

  // Look in the URL for a requested database.
  var db = window.location.search;
  if (db) {
    // Trim off the '?' and unescape the URI encoding
    db = decodeURI(db.substring(1));
  }
  if (!db) {
    // No database found.  Ask the user for one instead.
    db = window.prompt('Enter the filename of an XML Moo Database', 'Minimal.xml', 'Moo Database');
  }
  if (db) {
    fetchFile(db);
  }
}

function fetchFile(xmlUrl) {
  if (window.XMLHttpRequest) {  // W3.
     var xhr = new XMLHttpRequest();
  } else {  // IE.
     var xhr = new ActiveXObject('Microsoft.XMLHTTP');
  }
  try {
    xhr.open('GET', xmlUrl, true);
    xhr.setRequestHeader('Content-Type', 'text/xml');
    xhr.onreadystatechange = onloadXML;
    xhr.send();
  } catch (e) {
    // Attempt to diagnose the problem.
    var msg = 'Error: Unable to load XML data.\n';
    if (window.location.protocol == 'file:') {
      msg += 'This may be due to a security restriction preventing\n' +
          'access when using the file:// protocol.\n' +
          'Use an http webserver, or a less paranoid browser.\n';
    }
    alert(msg + '\n' + e);
  }
}

function onloadXML() {
  if (this.readyState != 4) {
    return;  // Not ready yet.
  } else if (this.status != 200) {
    alert('Error: XML load returned status ' + this.status);
    return;
  }
  TreeFrame.clear();
  XmlDoc = this.responseXML;

  var objectList = XmlDoc.getElementsByTagName('OBJECT');
  for (var i = 0, obj; obj = objectList[i]; i++) {
    TreeFrame.treeUpdateId(objectList[i].getAttribute('ID'), XmlDoc);
  }
  TreeFrame.treeFoldAll(false);
}

function getXmlNodeById(id) {
  var node;
  if (XmlDoc.querySelector) {  // W3.
    node = XmlDoc.querySelector('[ID=' + id + ']');
  } else {  // IE.
    node = XmlDoc.nodeFromID(id);
  }
  return node;
}

function getXmlNameFromNode(xmlNode) {
  var childXmlNodeLength = xmlNode.childNodes.length;
  var childXmlNode
  for (var x = 0; x < childXmlNodeLength; x++) {
    childXmlNode = xmlNode.childNodes[x];
    if (childXmlNode.nodeName == 'NAME' && childXmlNode.firstChild) {
      return childXmlNode.firstChild.nodeValue;
    }
  }
  return "";
}
